import unittest
from zlepy import eigs
import sympy as sp
import numpy as np
from tests.testing_utils import validate_eigs
import sys

np.set_printoptions(threshold=sys.maxsize)

N = 40
SYMBOLS_40 = sp.symbols('x_0:40')
A_40 = sp.Matrix(
        [
            [SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38]],
            [SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36]],
            [SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35]],
            [SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38]],
            [SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36]],
            [SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35]],
            [SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29]],
            [SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28]],
            [SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29]],
            [SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26]],
            [SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25]],
            [SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38]],
            [SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36]],
            [SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35]],
            [SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38]],
            [SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39]],
            [SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36]],
            [SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35]],
            [SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14]],
            [SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13]],
            [SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14]],
            [SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11]],
            [SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10]],
            [SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14]],
            [SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13]],
            [SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14]],
            [SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11]],
            [SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10]],
            [SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[37],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[32],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[27],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[17],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[22],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[12],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[7],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[0],SYMBOLS_40[1],SYMBOLS_40[2],SYMBOLS_40[3],SYMBOLS_40[4]],
            [SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[37],SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[32],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[27],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[17],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[22],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[12],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[7],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[2],SYMBOLS_40[4],SYMBOLS_40[3]],
            [SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0],SYMBOLS_40[3],SYMBOLS_40[4]],
            [SYMBOLS_40[38],SYMBOLS_40[39],SYMBOLS_40[37],SYMBOLS_40[35],SYMBOLS_40[36],SYMBOLS_40[33],SYMBOLS_40[34],SYMBOLS_40[32],SYMBOLS_40[30],SYMBOLS_40[31],SYMBOLS_40[28],SYMBOLS_40[29],SYMBOLS_40[27],SYMBOLS_40[25],SYMBOLS_40[26],SYMBOLS_40[18],SYMBOLS_40[19],SYMBOLS_40[17],SYMBOLS_40[15],SYMBOLS_40[16],SYMBOLS_40[23],SYMBOLS_40[24],SYMBOLS_40[22],SYMBOLS_40[20],SYMBOLS_40[21],SYMBOLS_40[13],SYMBOLS_40[14],SYMBOLS_40[12],SYMBOLS_40[10],SYMBOLS_40[11],SYMBOLS_40[8],SYMBOLS_40[9],SYMBOLS_40[7],SYMBOLS_40[5],SYMBOLS_40[6],SYMBOLS_40[3],SYMBOLS_40[4],SYMBOLS_40[2],SYMBOLS_40[0],SYMBOLS_40[1]],
            [SYMBOLS_40[39],SYMBOLS_40[38],SYMBOLS_40[37],SYMBOLS_40[36],SYMBOLS_40[35],SYMBOLS_40[34],SYMBOLS_40[33],SYMBOLS_40[32],SYMBOLS_40[31],SYMBOLS_40[30],SYMBOLS_40[29],SYMBOLS_40[28],SYMBOLS_40[27],SYMBOLS_40[26],SYMBOLS_40[25],SYMBOLS_40[19],SYMBOLS_40[18],SYMBOLS_40[17],SYMBOLS_40[16],SYMBOLS_40[15],SYMBOLS_40[24],SYMBOLS_40[23],SYMBOLS_40[22],SYMBOLS_40[21],SYMBOLS_40[20],SYMBOLS_40[14],SYMBOLS_40[13],SYMBOLS_40[12],SYMBOLS_40[11],SYMBOLS_40[10],SYMBOLS_40[9],SYMBOLS_40[8],SYMBOLS_40[7],SYMBOLS_40[6],SYMBOLS_40[5],SYMBOLS_40[4],SYMBOLS_40[3],SYMBOLS_40[2],SYMBOLS_40[1],SYMBOLS_40[0]]
        ]
    )

class TestParallelEigsDifferentBatchSizes(unittest.TestCase):
    
    def test_eig_with_high_batch_size(self):
        result = eigs(A_40, SYMBOLS_40, batch_size=40)
        self.assertTrue(validate_eigs(result, A_40, SYMBOLS_40))

    def test_eig_with_small_batch_size(self):
        result = eigs(A_40, SYMBOLS_40, batch_size=5)
        self.assertTrue(validate_eigs(result, A_40, SYMBOLS_40))
